ALTER TABLE NNLOCATION_SVG_DOC
ADD PIER_CODE VARCHAR2(2 CHAR);

ALTER TABLE NNLOCATION_SVG_DOC
ADD SVG_TYPE VARCHAR2(3 CHAR);

ALTER TABLE REZERVAC
ADD TIME_FROM DATE;

ALTER TABLE REZERVAC
ADD TIME_TO DATE;

ALTER TABLE M_POGODBE
ADD TIME_FROM DATE;

ALTER TABLE M_POGODBE
ADD TIME_TO DATE;

INSERT INTO FILE_DATA_TYPE(CODE, DESCRIPTION, INTERNAL_DESCRIPTION, ACTIVE) VALUES
('WBL', 'Web logo', 'Web logo', 'Y');

INSERT INTO FILE_DATA_TYPE(CODE, DESCRIPTION, INTERNAL_DESCRIPTION, ACTIVE) VALUES
('PRL', 'Portal logo', 'Portal logo', 'Y');

INSERT INTO FILE_DATA_TYPE(CODE, DESCRIPTION, INTERNAL_DESCRIPTION, ACTIVE) VALUES
('PML', 'Portal mobile logo', 'Portal mobile logo', 'Y');

UPDATE FILE_DATA F
SET F.TYPE = 'PRL', F.NNLOCATION_ID = (SELECT MAX(N.ID) FROM NNLOCATION N WHERE N.ID_PORTAL_LOGO_DATA = F.ID_FILE_DATA)
WHERE ID_FILE_DATA IN (SELECT ID_PORTAL_LOGO_DATA FROM NNLOCATION) AND F.TYPE IS NULL;

UPDATE FILE_DATA F
SET F.TYPE = 'WBL', F.NNLOCATION_ID = (SELECT MAX(N.ID) FROM NNLOCATION N WHERE N.ID_WEB_LOGO_DATA = F.ID_FILE_DATA)
WHERE ID_FILE_DATA IN (SELECT ID_WEB_LOGO_DATA FROM NNLOCATION) AND F.TYPE IS NULL;

UPDATE FILE_DATA F
SET F.TYPE = 'PML', F.NNLOCATION_ID = (SELECT MAX(N.ID) FROM NNLOCATION N WHERE N.ID_PORTAL_MOBILE_LOGO_DATA = F.ID_FILE_DATA)
WHERE ID_FILE_DATA IN (SELECT ID_PORTAL_MOBILE_LOGO_DATA FROM NNLOCATION) AND F.TYPE IS NULL;

INSERT INTO FILE_DATA(ID_FILE_DATA, FILE_ID, NAME, EXTENSION, DATA, DATE_CREATED, USER_CREATED, TYPE, ACT)
SELECT FILE_DATA_SEQ.NEXTVAL, 'PORTAL_LOGO', SUBSTR(IME_DATOTEKE, 1, INSTR(IME_DATOTEKE, '.', -1 ) - 1), UPPER(SUBSTR(IME_DATOTEKE, INSTR(IME_DATOTEKE, '.', -1 ) + 1)), DOKUMENT, SYSDATE, 'INFO', 'PRL', 'Y' 
FROM UPLOAD_DATA WHERE SIFRA = 'MARINA_MASTER_PORTAL_LOGO' AND NOT EXISTS (SELECT * FROM FILE_DATA WHERE FILE_ID = 'PORTAL_LOGO' AND ACT = 'Y');

INSERT INTO FILE_DATA(ID_FILE_DATA, FILE_ID, NAME, EXTENSION, DATA, DATE_CREATED, USER_CREATED, TYPE, ACT)
SELECT FILE_DATA_SEQ.NEXTVAL, 'WEB_LOGO', SUBSTR(IME_DATOTEKE, 1, INSTR(IME_DATOTEKE, '.', -1 ) - 1), UPPER(SUBSTR(IME_DATOTEKE, INSTR(IME_DATOTEKE, '.', -1 ) + 1)), DOKUMENT, SYSDATE, 'INFO', 'WBL', 'Y' 
FROM UPLOAD_DATA WHERE SIFRA = 'MARINA_MASTER_LOGO' AND NOT EXISTS (SELECT * FROM FILE_DATA WHERE FILE_ID = 'WEB_LOGO' AND ACT = 'Y');

DROP VIEW V_RESERVATIONS_MANAGEMENT;

CREATE OR REPLACE VIEW V_RESERVATIONS_MANAGEMENT AS 
(
SELECT 'ALARM_ARRIVAL' AS CATEGORY, CONCAT('ALARM_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) < TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2 AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE < RE.DATUM_REZERVACIJE AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC IN (1,2) )
UNION ALL
SELECT 'ALARM_DEPARTURE' AS CATEGORY, CONCAT('ALARM_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_DO) <= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC IN (1,2) AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)
UNION ALL
SELECT 'ALARM_MOVE' AS CATEGORY, CONCAT('ALARM_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD <= TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'ALARM_EXIT' AS CATEGORY, CONCAT('ALARM_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'ALARM_RETURN' AS CATEGORY, CONCAT('ALARM_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 2 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'PLAN_ARRIVAL' AS CATEGORY, CONCAT('PLAN_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) >= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2
UNION ALL
SELECT 'PLAN_DEPARTURE' AS CATEGORY, CONCAT('PLAN_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_DO) >= TRUNC(SYSDATE) AND (RE.STATUS_REZERVAC IN (1, 2) OR (RE.STATUS_REZERVAC IN (3, 4) AND RE.VRSTA = 'RE')) AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)
AND RE.DATUM_DO = (SELECT MAX(DE2.DATUM_DO) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = DE.ID_REZERVAC AND DE2.ID_PRIVEZ = DE.ID_PRIVEZ AND DE2.STATUS_REZERVAC = DE.STATUS_REZERVAC)
UNION ALL
SELECT 'PLAN_MOVE' AS CATEGORY, CONCAT('PLAN_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND NOT EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)
UNION ALL
SELECT 'PLAN_EXIT' AS CATEGORY, CONCAT('PLAN_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N')
UNION ALL
SELECT 'PLAN_RETURN' AS CATEGORY, CONCAT('PLAN_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)
UNION ALL
SELECT 'CURRENT_PRESENT' AS CATEGORY, CONCAT('CURRENT_PRESENT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE = 'Y')
UNION ALL
SELECT 'CURRENT_EXIT' AS CATEGORY, CONCAT('CURRENT_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO,
VD.N_PRIVEZA, VD.ID_PRIVEZ, VD.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT, RE.TIME_FROM, RE.TIME_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
LEFT OUTER JOIN (SELECT ID, N_PRIVEZA, ID_PRIVEZ, NNLOCATION_ID, ID_LASTNIKA, ID_PLOVILA, KATEGORIJA_DOGODKA, ROW_NUMBER() OVER (PARTITION BY ID_LASTNIKA, ID_PLOVILA, KATEGORIJA_DOGODKA ORDER BY ID DESC) RNK FROM V_DOGODKI) VD
ON (VD.ID_LASTNIKA = RE.ID_LASTNIKA AND VD.ID_PLOVILA = RE.ID_PLOVILA AND VD.RNK = 1 AND VD.KATEGORIJA_DOGODKA = 'IZ')
WHERE RE.STATUS_REZERVAC = 2 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE = 'Y')
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1588, SYSDATE, '5.5', 1508, 'FileData logo')
;