CREATE TABLE CARPARK_IMPORT (
ID NUMBER   NOT NULL,
ID_IMPORT   NUMBER NOT NULL,
TRANS_ID    NUMBER,
TRANS_DATE  DATE,
SERVER_ID   NUMBER,
DOOR_ID     NUMBER,
USER_ID     NUMBER,
ACCESS_TYPE NUMBER,
ACCESS_LOG  VARCHAR2(50 CHAR),
UPDATED     VARCHAR2(50 CHAR),
CARD_ID     VARCHAR2(15 CHAR),
STATUS      VARCHAR2(1 CHAR),
CONSTRAINT PK_CARPARK_IMPORT PRIMARY KEY (ID)
);
 
CREATE INDEX carpark_import_ndx1 ON carpark_import(trans_id);
 
CREATE SEQUENCE CARPARK_IMPORT_ID_SEQ START WITH 1 NOCYCLE;
 
 
CREATE OR REPLACE
TRIGGER CARPARK_IMPORT_trg
BEFORE INSERT
ON CARPARK_IMPORT
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
     IF (:NEW.ID IS NULL) THEN
          SELECT CARPARK_IMPORT_ID_SEQ.NEXTVAL INTO :NEW.ID  FROM dual;
     END IF;        
END;
;
CREATE TABLE CARPARK_CALC (
ID                NUMBER NOT NULL,
ID_IMPORT         NUMBER NOT NULL,
MEMBER_ID         NUMBER,
CARD_ID           VARCHAR2(15 CHAR),
ARRIVAL           DATE,
DEPARTURE         DATE,
TRANS_ID_ARRIVAL  NUMBER,
TRANS_ID_DEPART   NUMBER,
HOURS_DAILY       NUMBER,
HOURS_NIGHTLY     NUMBER,
PARK_COST         NUMBER,
DISCOUNT          NUMBER,
STATUS            VARCHAR2(1 CHAR),
ID_OBDELAVE       NUMBER,
ID_STORITVE       NUMBER,
CONSTRAINT "PK_CARPARK_CALC" PRIMARY KEY (ID)
);
 
CREATE SEQUENCE CARPARK_CALC_ID_SEQ START WITH 1 NOCYCLE;
 
 
CREATE OR REPLACE
TRIGGER CARPARK_CALC_trg
BEFORE INSERT
ON CARPARK_CALC
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
     IF (:NEW.ID IS NULL) THEN
          SELECT CARPARK_CALC_ID_SEQ.NEXTVAL INTO :NEW.ID  FROM dual;
     END IF;        
END;
;

-- Podtipi eventov
CREATE TABLE SC_EVSUB (
  ID INTEGER NOT NULL,
  SC_EVTYPE_ID INTEGER NOT NULL,
  NAME VARCHAR2(250) NOT NULL,
  PRICE NUMBER NOT NULL,
  PRICE_MEMBER NUMBER NOT NULL
);

ALTER TABLE SC_EVSUB ADD CONSTRAINT SC_EVSUB_PK PRIMARY KEY (ID);

ALTER TABLE SC_EVSUB ADD CONSTRAINT SC_EVSUB_U1 UNIQUE (SC_EVTYPE_ID, NAME);

ALTER TABLE SC_EVSUB ADD CONSTRAINT SC_EVSUB_EVTYPE_FK FOREIGN KEY (SC_EVTYPE_ID) REFERENCES SC_EVTYPE (ID);

CREATE SEQUENCE SC_EVSUB_SEQ START WITH 1;

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(456, SYSDATE, '5.5', 376, 'CARPARK');