CREATE OR REPLACE VIEW V_KUPCI AS (
	SELECT K.ID, K.ID_MEMBER, K.IME, K.PRIIMEK, K.MESTO, K.NASLOV, K.POSTA, K.TELEFON_1, K.EMAIL, K.YACHT_CLUB_ID, K.TELEX, K.VRSTA, K.NDRZAVA, K.SALDAKONTI_SIT, K.SALDAKONTI_DEM, K.SALDAKONTI_KOM,
	NNTIT.INTERNI_OPIS AS NNTITLE_DESC, NNDRZ.INTERNI_OPIS AS NNDRZAVA_DESC, NNDOK.INTERNI_OPIS AS VRSTA_DOKUMENTA_DESC, NNVRS.INTERNI_OPIS AS VRSTA_DESC,
	NNDRZDR.INTERNI_OPIS AS DRZAVA_ROJSTVA_DESC, NNDRZCI.INTERNI_OPIS AS CITIZENSHIP_DESC, NNMAR.INTERNI_OPIS AS MARITAL_STATUS_DESC,
  
    -- Owner balance data
    K.SALDAKONTI_SIT + NVL(K.SALDAKONTI_DEM, 0) * (SELECT NVL(LAST_MIDDLE_RATE, 1) FROM V_FOREIGN_RATE) AS BALANCE, 
    CASE WHEN K.VALUTA_PLACILA = (SELECT TUJAVALUTA FROM PARAM) THEN NVL(K.SALDAKONTI_KOM, 0)*(-1)*(SELECT NVL(LAST_MIDDLE_RATE, 1) FROM V_FOREIGN_RATE) ELSE NVL(K.SALDAKONTI_KOM, 0)*(-1) END AS COMMERCIAL_BALANCE,
    
    (K.SALDAKONTI_SIT + NVL(K.SALDAKONTI_DEM, 0) * (SELECT NVL(LAST_MIDDLE_RATE, 1) FROM V_FOREIGN_RATE)) + 
    (CASE WHEN K.VALUTA_PLACILA = (SELECT TUJAVALUTA FROM PARAM) THEN NVL(K.SALDAKONTI_KOM, 0)*(-1)*(SELECT NVL(LAST_MIDDLE_RATE, 1) FROM V_FOREIGN_RATE) ELSE NVL(K.SALDAKONTI_KOM, 0)*(-1) END) AS TOTAL_BALANCE,
    
    ((SELECT NVL(SUM( (S.ZA_PLACILO - S.PORABLJENO)*NVL(S.TECAJ_VALUTE,1) ), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND UPPER(S.VALUTA_RN) = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_PL) = 'P' AND UPPER(S.SDK_RN_TIP) = 'I' AND S.ZAPRTO = '0' AND S.DATUM_VALUTACIJE < SYSDATE) -
    (SELECT NVL(SUM( (S.ZA_PLACILO - S.PORABLJENO)*NVL(S.TECAJ_VALUTE,1) ), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND UPPER(S.VALUTA_RN) = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_PL) = 'R' AND UPPER(S.SDK_RN_TIP) = 'I' AND S.ZAPRTO = '0' AND S.DATUM_VALUTACIJE < SYSDATE)) AS OUTSTANDING_BALANCE,
  
    -- Owner contract data
   (SELECT OBJEKT FROM M_POGODBE M WHERE M.ID_LASTNIKA = K.ID AND M.ID_PLOVILA IS NULL AND ROWNUM = 1 AND M.DATUM_ZACETKA = (SELECT MAX(M2.DATUM_ZACETKA) FROM M_POGODBE M2 WHERE M2.ID_LASTNIKA = K.ID AND M2.ID_PLOVILA IS NULL) ) AS POGODBA_OBJEKT,
   (SELECT N_PRIVEZA FROM M_POGODBE M WHERE M.ID_LASTNIKA = K.ID AND M.ID_PLOVILA IS NULL AND ROWNUM = 1 AND M.DATUM_ZACETKA = (SELECT MAX(M2.DATUM_ZACETKA) FROM M_POGODBE M2 WHERE M2.ID_LASTNIKA = K.ID AND M2.ID_PLOVILA IS NULL) ) AS POGODBA_PRIVEZ
   
	FROM KUPCI K
	LEFT OUTER JOIN NNTITLE NNTIT ON K.NTITLE = NNTIT.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZ ON K.NDRZAVA = NNDRZ.SIFRA
	LEFT OUTER JOIN NNDOKUME NNDOK ON K.VRSTA_DOKUMENTA = NNDOK.SIFRA
	LEFT OUTER JOIN NNVRSKUP NNVRS ON K.VRSTA = NNVRS.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZDR ON K.DRZAVA_ROJSTVA = NNDRZDR.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZCI ON K.CITIZENSHIP = NNDRZCI.SIFRA
	LEFT OUTER JOIN NNMARSTAT NNMAR ON K.MARITAL_STATUS = NNMAR.SIFRA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (978, SYSDATE, '5.5', 898, 'VKupci saldkont tecaj');